/*
 * uart.h -- hardware UART interface
 *
 * Copyright (C) 2016-2017 Tomasz Kramkowski <tk@the-tk.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef FMK_UART_H
#define FMK_UART_H

#ifdef WITH_UART
void uart_setup(void);
void uart_putchar(int c);
void uart_printf(const char *fmt, ...);
void uart_puts(const char *s);
#else
static inline void uart_setup(void) { }
static inline void uart_putchar(int c) { (void)c; }
static inline void uart_printf(const char *fmt, ...) { (void)fmt; }
static inline void uart_puts(const char *s) { (void)s; }
#endif

#endif /* FMK_UART_H */
