/*
 * usb/txhandler.h -- USB Transmission Handling
 *
 * Copyright (C) 2017 Tomasz Kramkowski <tk@the-tk.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef FMK_USB_TXHANDLER_H
#define FMK_USB_TXHANDLER_H

#include <reg/usbotg.h>
#include <stdbool.h>
#include <stddef.h>

struct tx_ctx {
	volatile struct usb0_bd *bdt;
	bool odd, data01;
	void *data;
	size_t size, max;
};
#define TX_CTX(b, m) ((struct tx_ctx){ .bdt = (b), .max = (m) })

void tx_que(struct tx_ctx *tx, void *data, size_t size);
bool tx_push(struct tx_ctx *tx);
bool tx_isempty(struct tx_ctx *tx);

#endif /* FMK_USB_TXHANDLER_H */
